"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _signals = require("signals");

var _Utils = require("./Utils");

var Utils = _interopRequireWildcard(_Utils);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var CacheDependency = function () {
    function CacheDependency(keys, dependencies) {
        var _this = this;

        _classCallCheck(this, CacheDependency);

        this._map = Object.create(null);

        (keys ? Array.isArray(keys) ? keys : [keys] : []).forEach(function (key) {
            var keyStruct = Utils.getKeyStruct(key);
            _this._map[keyStruct.keyStr] = key;
        });

        this._deps = dependencies ? Array.isArray(dependencies) ? dependencies : [dependencies] : [];

        for (var i = 0; i < this._deps.length; i++) {
            if (!(this._deps[i] instanceof CacheDependency)) throw new Error("'dependencies' should be one or more 'CacheDependency' instances");
        }this.triggered = new _signals.Signal();
        this._isTriggered = false;
    }

    _createClass(CacheDependency, [{
        key: "isTriggered",
        value: function isTriggered() {
            return this._isTriggered;
        }
    }, {
        key: "getLastModified",
        value: function getLastModified() {
            return this._triggeredDate;
        }
    }, {
        key: "_hasKeys",
        value: function _hasKeys() {
            var has = false;

            for (var _ in this._map) {
                has = true;
                break;
            }

            return has;
        }
    }, {
        key: "_attach",
        value: function _attach(cache) {
            if (this._cache) throw new Error("dependency already attached");

            this._cache = cache;

            if (this._hasKeys()) cache.itemRemoved.add(this._handleRemovedItem, this);

            for (var i = 0; i < this._deps.length; i++) {
                this._deps[i].triggered.addOnce(this._setTriggered, this);
            }
        }
    }, {
        key: "_detach",
        value: function _detach() {
            if (this._hasKeys()) this._cache.itemRemoved.remove(this._handleRemovedItem, this);

            for (var i = 0; i < this._deps.length; i++) {
                this._deps[i].triggered.remove(this._setTriggered, this);
            }this._cache = null;
        }
    }, {
        key: "_handleRemovedItem",
        value: function _handleRemovedItem(key /*, value, reason*/) {
            var keyStruct = Utils.getKeyStruct(key);

            if (this._map[keyStruct.keyStr] !== void 0) this._setTriggered();
        }
    }, {
        key: "_setTriggered",
        value: function _setTriggered() {
            this._detach();

            this._isTriggered = true;
            this._triggeredDate = new Date();

            this.triggered.dispatch();
        }
    }]);

    return CacheDependency;
}();

exports.default = CacheDependency;


module.exports = CacheDependency;