declare namespace CacheNet {
    export interface CacheOptions {
        dependencies?: CacheDependency | CacheDependency[]
        slidingExpirationMsec?: number
        absoluteExpiration?: Date | ((options: CacheOptions) => Date)
        removeCallback?: (key: string, value: any, reason: string) => any
    }

    export class Cache {
        maxSize: number
        itemRemoved: Signal

        constructor(maxSize: number)

        set(key: any, value: any, options?: CacheOptions): void
        get(key: any)
        has(key: any | any[]): boolean
        remove(key: any | any[], reason?: string): void
        clear(testFn?: (key: any, value: any) => boolean): number
        getSize(): number
        enumerate(fn: (key: any, data: any) => boolean): void
    }

    export class CacheDependency {
        triggered: Signal

        constructor(keys: any | any[], dependencies: CacheDependency | CacheDependency[])

        isTriggered(): boolean
        getLastModified(): Date
    }
}

export = CacheNet
